
function varargout = Classical_reconstruction(varargin)
% License owner: Mozhdeh Seifi, Corinne Fournier, Loic Denis
%
% This work is licensed under a Creative Commons Attribution 
% Non-Commercial No Derivatives 3.0 France license. In essence, 
% you are free to copy and communicate the work in its current form
% for non-commercial purposes, as long as you attribute the authors
% and abide by the license terms.
% You may not alter or adapt the work in any way.
%
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/3.0/
%-------------------------------------------------------------------------%
% CLASSICAL_RECONSTRUCTION MATLAB code for Classical_reconstruction.fig
%      CLASSICAL_RECONSTRUCTION, by itself, creates a new CLASSICAL_RECONSTRUCTION or raises the existing
%      singleton*.
%
%      H = CLASSICAL_RECONSTRUCTION returns the handle to a new CLASSICAL_RECONSTRUCTION or the handle to
%      the existing singleton*.
%
%      CLASSICAL_RECONSTRUCTION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLASSICAL_RECONSTRUCTION.M with the given input arguments.
%
%      CLASSICAL_RECONSTRUCTION('Property','Value',...) creates a new CLASSICAL_RECONSTRUCTION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Classical_reconstruction_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Classical_reconstruction_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Classical_reconstruction

% Last Modified by GUIDE v2.5 26-Oct-2012 09:35:22

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Classical_reconstruction_OpeningFcn, ...
                   'gui_OutputFcn',  @Classical_reconstruction_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Classical_reconstruction is made visible.
function Classical_reconstruction_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Classical_reconstruction (see VARARGIN)
load path_data.mat
load joint_path.mat
global Reconst;
global Visual_src;
global indZ;
global Z;
global changeParam;
global method_rec;
global Ze_pad;
global Save_o;
global first_launch;
first_launch=1;
changeParam=0;
Visual_src=1;
method_rec=0;
Ze_pad=1;
Save_o=1;
%%% initialization of panels handles
set(handles.uipanel2,'SelectionChangeFcn',@uipanel2_SelectionChangeFcn);
set(handles.uipanel3,'SelectionChangeFcn',@uipanel3_SelectionChangeFcn);
set(handles.uipanel5,'SelectionChangeFcn',@uipanel5_SelectionChangeFcn);
set(handles.slider1, 'Min',0.1);
set(handles.slider1, 'Max',0.3);

set(handles.slider1, 'Value',0.1);
set(handles.slider1, 'SliderStep',[0.05 0.25]);

guidata(hObject, handles);



%%% initialization of Z
lb= str2num(get(handles.edit3,'String'));
stepZ = str2num(get(handles.edit6,'String'));
ub = str2num(get(handles.edit4,'String'));
Z=lb:stepZ(1):ub;
indZ=1;

%%% recinstruction Default
if exist(strcat(path_data,'Reconst_classicDEF.mat'),'file')
    Reconst =struct2cell(load(strcat(path_data,'Reconst_classicDEF.mat')));
    Reconst =Reconst {1,1};

    
    imageArray =real(Reconst(:,:,indZ));
    imageArray=(imageArray-min(min(imageArray)))./(max(max(imageArray))-min(min(imageArray)));
    axes(handles.axes4);
    imshow(imageArray);
    % Update handles structure
    guidata(hObject, handles);

    imageArray =imag(Reconst(:,:,indZ));
    imageArray=(imageArray-min(min(imageArray)))./(max(max(imageArray))-min(min(imageArray)));
    axes(handles.axes5);
    imshow(imageArray);
    guidata(hObject, handles);
end
%%% printing logos
handles.output = hObject;
guidata(hObject, handles);
imageArray =imread('logo_h.jpg');
axes(handles.axes1);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);

imageArray =imread('logo_univ.jpg');
axes(handles.axes3);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);

imageArray =imread('license.png');
axes(handles.axes2);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);


%%% initialization of internal variables


IA_name='RulerHolo_classicalREC.mat';
save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');

IA_path=path_data;
save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Classical_reconstruction wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Classical_reconstruction_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function uipanel2_SelectionChangeFcn(hObject, eventdata)
load path_data.mat
load joint_path.mat
%retrieve GUI data, i.e. the handles structure
handles = guidata(hObject); 
global changeParam;
global Ze_pad;
changeParam=1;
switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
    case 'radiobutton1'
        Ze_pad=1;
%         save(strcat(strcat(strcat(path_data,'temp'),joint),'Ze_pad.mat'),'Ze_pad');
        
    case 'radiobutton2'
      %execute this code when radiobutton2 is selected
      Ze_pad=0;
%       save(strcat(strcat(strcat(path_data,'temp'),joint),'Ze_pad.mat'),'Ze_pad');

    otherwise
      Ze_pad=1;
%       save(strcat(strcat(strcat(path_data,'temp'),joint),'Ze_pad.mat'),'Ze_pad');

end
%updates the handles structure
guidata(hObject, handles);

function uipanel3_SelectionChangeFcn(hObject, eventdata)
load path_data.mat
load joint_path.mat
%retrieve GUI data, i.e. the handles structure
handles = guidata(hObject); 
global method_rec;
global changeParam;
changeParam=1;
switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
    case 'radiobutton3'
        method_rec=0;
%         save(strcat(strcat(strcat(path_data,'temp'),joint),'method_rec.mat'),'method_rec');
        
    case 'radiobutton4'
      %execute this code when radiobutton4 is selected
          method_rec=1;
%           save(strcat(strcat(strcat(path_data,'temp'),joint),'method_rec.mat'),'method_rec');

    otherwise
      method_rec=0;
%       save(strcat(strcat(strcat(path_data,'temp'),joint),'method_rec.mat'),'method_rec');

end

%updates the handles structure
guidata(hObject, handles);


function uipanel5_SelectionChangeFcn(hObject, eventdata)
load path_data.mat
load joint_path.mat
global Visual_src;
handles = guidata(hObject); 
switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
    case 'radiobutton7'
        Visual_src=1;
        save(strcat(strcat(strcat(path_data,'temp'),joint),'Visual_src.mat'),'Visual_src');
        set(handles.text18,'String','Real');
        set(handles.text19,'String','Imaginary');
        plot_results(hObject, eventdata, handles);
    case 'radiobutton8'
      %execute this code when radiobutton4 is selected
          Visual_src=0;
          save(strcat(strcat(strcat(path_data,'temp'),joint),'Visual_src.mat'),'Visual_src');
          set(handles.text18,'String','Intensity');
          set(handles.text19,'String','Phase');
          plot_results(hObject, eventdata, handles);
    otherwise
         Visual_src=1;
         save(strcat(strcat(strcat(path_data,'temp'),joint),'Visual_src.mat'),'Visual_src');
         set(handles.text18,'String','Real');
         set(handles.text19,'String','Imaginary');
end
guidata(hObject, handles);


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
global Reconst;
global indZ;
global Z;
global changeParam;
global first_launch;
lb= str2num(get(handles.edit3,'String'));
stepZ = str2num(get(handles.edit6,'String'));
ub = str2num(get(handles.edit4,'String'));
Z=lb:stepZ(1):ub;

if first_launch
        errordlg('Please first select a hologram','Error');
        return;
else
        IA_path=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat')));
        IA_path=IA_path{1,1};
        
        IA_name=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat')));
        IA_name=IA_name{1,1};

        Wait_Anounce
        
        hol=struct2cell(load(strcat(IA_path,IA_name)));
        hol=cell2mat(hol);
        
        if size(hol,3)>1
            
            errordlg('Please select the .Mat file to load only one hologram ','Error');
            return
        else
            
            
                

                Calc_reconst(hObject, eventdata, handles,hol);%Reconst,
                
                changeParam=0;
                
                
                
                Save_o = Save_Reconstruction('Title','Confirm Save');
                
               
                 switch Save_o
                     case {'No'}
                     case 'Yes'
                     fprintf('Saving the reconstructed volume ...');
                        save(strcat(path_data,'Reconst_classic.mat'),'Reconst');
                        fprintf('Saving finished \n');
                 end
                 
                save(strcat(strcat(strcat(path_data,'temp'),joint),'Z_classic.mat'),'Z');
                val=get(handles.slider1,'Min');
                set(handles.slider1,'Value',val);
                set(handles.text17,'String',val);
                
                ind=find(abs(Z-val)<eps);
                if numel(ind)==0
                    errordlg('Reconstruction failed','Error');

                else
                    indZ=ind;
%                     Reconst=Reconst(:,:,ind);
                    plot_results(hObject, eventdata, handles);%Reconst,
                    close Wait_Anounce
                end
        end
end
guidata(hObject, handles);

function plot_results(hObject, eventdata, handles)%,Reconst)
global Reconst;
global indZ;
global Visual_src;                
global changeParam;
if  changeParam 
    errordlg('You need to reconstruct the volume every time you change the parameter settings','Error');
    return;
else
    
% figure(1000);subplot(1,2,1);imshow(abs(Reconst(:,:,ind)),[]);
if Visual_src
    imageArray =real(Reconst(:,:,indZ));
else 
    imageArray =abs(Reconst(:,:,indZ));
end

imageArray=(imageArray-min(min(imageArray)))./(max(max(imageArray))-min(min(imageArray)));
axes(handles.axes4);
imshow(imageArray);axis on;
% Update handles structure
guidata(hObject, handles);

% figure(1000);subplot(1,2,2);imshow(angle(Reconst(:,:,ind)),[]);
if Visual_src
    imageArray =imag(Reconst(:,:,indZ)); 
else
    imageArray =angle(Reconst(:,:,indZ));
end
imageArray=(imageArray-min(min(imageArray)))./(max(max(imageArray))-min(min(imageArray)));
axes(handles.axes5);

imshow(imageArray);axis on
% Update handles structure
guidata(hObject, handles);
end

function Calc_reconst(hObject, eventdata, handles,hol)%Reconst 
clc
load path_data.mat
load joint_path.mat
global Reconst;
global Z;
global method_rec;
global Ze_pad;
K = str2num(get(handles.edit5,'String'));
pix = str2num(get(handles.edit2,'String'));
lambda = str2num(get(handles.edit1,'String'));


           
meanH=mean(hol(:));
hol=hol-meanH;
      
hol_size=size(hol);       
if Ze_pad

      holog=zeros(hol_size*2);
      holog(hol_size(1)/2+1:3*hol_size(1)/2,hol_size(2)/2+1:3*hol_size(2)/2,:)=hol;
      
else
      holog=hol;
end
Reconst=zeros(hol_size(1),hol_size(2),numel(Z));  
hol_size1=size(holog);
dum=zeros(hol_size1);  

Z(find(Z==0))=eps;
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         Reconstruction      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~method_rec % fresnel transform
     
     
     Z_nyq= min(hol_size1*pix)^2/min(hol_size1)/lambda; % Nyquist frequency
     
     
     c=0;
      
    [p j]=meshgrid(floor(-hol_size1(2)/2):floor(hol_size1(2)/2)-1,floor(-hol_size1(1)/2):floor(hol_size1(1)/2)-1);  
    
     
             
     ind=find(abs(Z) <= Z_nyq);
     if numel(ind)>0
            Z_bi=Z(ind);
                    

              Ro=(j/hol_size1(1)/pix).^2+(p/hol_size1(2)/pix).^2;      
             for ii=1:numel(Z_bi)
                  c=c+1;
                  
                  Hz=exp(1i*pi*lambda*Z_bi(ii)*Ro);
                   
                   dum=ifft2(fft2(holog).*fftshift(Hz));
                   
                   if Ze_pad
                        Reconst(:,:,c)=dum(floor(hol_size(1)/2)+1:3*floor(hol_size(1)/2),floor(hol_size(2)/2)+1:3*floor(hol_size(2)/2));
                   else
                       Reconst(:,:,c)=dum;
                   end
                      
                   
%                    Reconst(:,:,c)=(Reconst(:,:,c)-min(min(Reconst(:,:,c))))./(max(max(Reconst(:,:,c)))-min(min(Reconst(:,:,c))));
% 
                  
                   fprintf('Reconstruction using Transfer Function Hz for z=%g is done\n',Z_bi(ii));
              end
     end    
    
    
    ind=find(abs(Z)>Z_nyq); % in space domain
    if numel(ind)>0
        Ro=(j*pix).^2+(p*pix).^2;
          Z_sm=Z(ind);
          
           for ii=1:numel(Z_sm)
                  c=c+1;
                   hz =1/1i/lambda/Z_sm(ii).*exp(pi*1i*Ro/lambda/Z_sm(ii));
                   
                   dum=ifftshift(ifft2(fft2(holog).*fft2(hz)));
                   
                   if Ze_pad
                        Reconst(:,:,c)=dum(floor(hol_size(1)/2)+1:3*floor(hol_size(1)/2),floor(hol_size(2)/2)+1:3*floor(hol_size(2)/2));
                   else
                       Reconst(:,:,c)=dum;
                   end
                   
%                    Reconst(:,:,c)=(Reconst(:,:,c)-min(min(Reconst(:,:,c))))./(max(max(Reconst(:,:,c)))-min(min(Reconst(:,:,c))));
                   
                   fprintf('Reconstruction using impulse response hz for z=%g is done\n',Z_sm(ii));

            end
     end

       clear Ro 
       clear p j         
    fprintf('Z nyquist = %g\n',Z_nyq); 
    
    
else % angular spectrum
    c=0;
    
        [p j]=meshgrid(floor(-hol_size1(2)/2):floor(hol_size1(2)/2)-1,floor(-hol_size1(1)/2):floor(hol_size1(1)/2)-1);  

        Ro1=(j/hol_size1(1)/pix).^2+(p/hol_size1(2)/pix).^2;
        Ro2=(j*pix).^2+(p*pix).^2;
        for ii=1:numel(Z)
            c=c+1;
            dum=exp(1i*pi*lambda*Z(ii).*Ro1).*fftshift(fft2(fftshift(conj(holog) .* 1/1i/lambda/Z(ii) .*exp(1i*pi*Ro2/lambda/Z(ii))  ) ));
                  
            if Ze_pad
               Reconst(:,:,c)=dum(floor(hol_size(1)/2)+1:3*floor(hol_size(1)/2),floor(hol_size(2)/2)+1:3*floor(hol_size(2)/2));
            else

                Reconst(:,:,c)=dum;               
            end
                   
%             Reconst(:,:,c)=(Reconst(:,:,c)-min(min(Reconst(:,:,c))))./(max(max(Reconst(:,:,c)))-min(min(Reconst(:,:,c))));
            fprintf('Reconstruction for z=%g is done\n',Z(ii));
        end
end


           
function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
global changeParam;
changeParam=1;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double
global changeParam;
changeParam=1;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double
global Z;
global changeParam;
changeParam=1;
LB0=get(handles.slider1,'Min');
LB1=str2double(get(handles.edit3,'String'));

if isnan(LB1)
    return;
else
    UB=get(handles.slider1,'Max');
    if UB<=LB1
        errordlg('Lower bound on Z should be smaller than the upper bound','Error');
    else

        if  get(handles.slider1,'Value')<LB1
            set(handles.slider1,'Value',LB1);
        end
        set(handles.slider1,'Min',LB1);

        stepZ = str2num(get(handles.edit6,'String'));
        Z=LB1:stepZ:UB;

        % stepz= str2double(get(handles.edit6,'String'))
        SS=get(handles.slider1, 'SliderStep');

        SS(1)=SS(1)*(UB-LB0)/(UB-LB1);
        SS(2)=SS(2)*(UB-LB0)/(UB-LB1);

        set(handles.slider1, 'SliderStep', SS);
    end
end
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double
global Z;
global changeParam;
changeParam=1;
UB1=str2double(get(handles.edit4,'String'));
UB0=get(handles.slider1,'Max');

if isnan(UB1)
    return;
else
    LB=get(handles.slider1,'Min');
    
    if UB1<=LB
        errordlg('Lower bound on Z should be smaller than the upper bound','Error');
    else
        if  get(handles.slider1,'Value')>UB1

            set(handles.slider1,'Value',UB1);
        end

        set(handles.slider1,'Max',UB1);


        stepZ = str2num(get(handles.edit6,'String'));
        Z=LB:stepZ:UB1;
    %     ind=find(Z<0);
    %     Z(ind)=-Z(ind);
        % stepz= str2double(get(handles.edit6,'String'));

        SS=get(handles.slider1, 'SliderStep');

        SS(1)=SS(1)*(UB0-LB)/(UB1-LB);
        SS(2)=SS(2)*(UB0-LB)/(UB1-LB);

        set(handles.slider1, 'SliderStep', SS);
    end
end
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit6_Callback(hObject, eventdata, handles)
global Z;
global changeParam;
changeParam=1;
stepZ=str2double(get(handles.edit6,'String'));

if isnan(stepZ)
    return;
else
LB=get(handles.slider1,'Min');
UB=get(handles.slider1,'Max');
Z1=LB:stepZ:UB;
if numel(Z1)<1
    errordlg('Please provide the sampling step size so that at least one reconstruction depth value is available between the lower bound and the upper bound on Z','Error');
    return;
else
    Z=Z1;
    SS=get(handles.slider1, 'SliderStep');

    SS(1)=stepZ/(UB-LB);
    SS(2)=2*stepZ/(UB-LB);

    set(handles.slider1, 'SliderStep', SS);
end
end
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in zoom_but.
function togglebutton1_Callback(hObject, eventdata, handles)
aa=get(handles.togglebutton1,'Value');
if aa~=0
   axes(handles.axes4)
   zoom on
end
if aa==0
   axes(handles.axes4)
   zoom off;
end
guidata(hObject,handles);

% --- Executes on button press in zoom_but.
function togglebutton2_Callback(hObject, eventdata, handles)
aa=get(handles.togglebutton2,'Value');
if aa~=0
   axes(handles.axes4)
   datacursormode on
end
if aa==0
   axes(handles.axes4)
   datacursormode off;
end
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double
global changeParam;
changeParam=1;
guidata(hObject,handles);

% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
load path_data.mat
load joint_path.mat
global indZ;
global Z;
global changeParam;

if changeParam
        errordlg('You need to reconstruct the volume every time you change the parameter settings','Error');
return;
else
    
ss= get(handles.slider1,'SliderStep');
maxx=get(handles.slider1,'Max');
minn=get(handles.slider1,'Min');

temp=ss(1)*(maxx-minn);
% minR=ss(1)*(maxx-minn);
minR=minn-floor(minn/temp)*temp;

if minR<eps
    minR=0;
end
val=get(handles.slider1,'Value');
% save val.mat val
val=round((val)/temp)*temp+minR;


if val>=get(handles.slider1,'Max')
   set(handles.slider1,'Value',get(handles.slider1,'Max'));
   set(handles.text17,'String',get(handles.slider1,'Max'));
   
       indZ=numel(Z);
        Wait_Anounce
        % Reconst=struct2cell(load(strcat(path_data,'Reconst_classic.mat')));
        % Reconst=Reconst{1,1};

        % Reconst=Reconst(:,:,ind);
        

        plot_results(hObject, eventdata, handles);%,Reconst);
        close Wait_Anounce
else
set(handles.slider1,'Value',val);

set(handles.text17,'String',val);

    ind=find(abs(Z-val)<2*eps);
    if numel(ind)==0
        errordlg('Something is wrong with the current value of Z and the set of depth values. Please check the application parameters, and reconstruct the volume again.','Error');

    else
        indZ=ind;
        Wait_Anounce
        % Reconst=struct2cell(load(strcat(path_data,'Reconst_classic.mat')));
        % Reconst=Reconst{1,1};

        % Reconst=Reconst(:,:,ind);


        plot_results(hObject, eventdata, handles);%,Reconst);
                close Wait_Anounce
    end
end
end
% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
global first_launch;
[FileName,PathName] = uigetfile('*.*','Select the file containing only one hologram');

if  (FileName==0) 
        %    'Please select the .Mat file to load the hologram'
           errordlg('Task cancelled','Error');
           return
        else 
            [pathstr, name, ext] = fileparts(FileName);
            if  (((strcmp('.mat',ext)==0 && strcmp('.png',ext)==0) && (strcmp('.tif',ext)==0 && strcmp('.jpg',ext)==0)) && strcmp('.jpeg',ext)==0) 
                'Please select the .Mat file to load the hologram'
                errordlg('Please select the .Mat file to load only one hologram','Error');
                return
            elseif  strcmp('.mat',ext)==1 
                first_launch=0;
                IA_name=FileName;
                IA_path=PathName;
                
                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');

                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');
                
            else
                first_launch=0;
                hol=double(imread(strcat(PathName,FileName)));
                if size(hol,3)>1
                    errordlg('Your image contains more than one color channel - We use a gray scale vesrion of your image for this toolbox','Warning');pause(2);
%                     for i=1:size(hol,3)
                        hol=mean(hol,3);
                end
                IA_name=strcat(name,'.mat');
               
                IA_path=path_data;
                
                save(strcat(IA_path,IA_name),'hol');
                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');

                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');
            end
end
